/* ***************
Desc: Installation script
Modified version of Chris Pederick installscript from WD.
Author: Jed Brown (jedbro@gmx.net)
Version: 0.5.x
Last modified: 2004-06-29
Modified by: Travis Hardiman (travis.hardiman@gmail.com)
****************** */
const author                = "Travis Hardiman";
const displayName           = "ImageZoomer";
const name                  = "imagezoomer";
const version               = "0.2";
var contentFlag             = CONTENT | PROFILE_CHROME;
var error                   = null;
var folder                  = getFolder("Profile", "chrome");
var localeFlag              = LOCALE | PROFILE_CHROME;
var skinFlag                = SKIN | PROFILE_CHROME;
var jarName                 = name + ".jar";
var existsInApplication     = File.exists(getFolder(getFolder("chrome"), jarName));
var existsInProfile         = File.exists(getFolder(folder, jarName));
const APP_LOCALE_FOLDERS    = new Array("locale/en-US/", "locale/eo/", "locale/en/");
// TODO: Localize messages for installation
// TODO: separate messages into separate info file for localization eg messages    = loadResources('locale.inf')
const CONFIRM_MESSAGE       = "Do you want to install the extension into your profile folder?\n(Cancel will install into the application folder)";
const SUCCESS_MESSAGE_START = " has been succesfully installed.\n";
const SUCCESS_MESSAGE       = " can now be found on the context menu for images. \n Please restart the application or open a new window for completion.";
const INSTALL_FAILURE       = "Install failed. Error code:";
const JAR_FAILURE_START     = "The installation of the extension failed.\n";
const JAR_FAILURE_MIDDLE    = "\n Failed to create ";
const JAR_FAILURE_END       = " \nMake sure you have the correct permissions";

initInstall(displayName, name, version);

// If the extension exists in the application folder or it doesn't exist in the profile folder and the user doesn't want it installed to the profile folder
if (existsInApplication || (!existsInProfile && !confirm(CONFIRM_MESSAGE)))
{
    contentFlag = CONTENT | DELAYED_CHROME;
    folder      = getFolder("chrome");
    localeFlag  = LOCALE | DELAYED_CHROME;
    skinFlag    = SKIN | DELAYED_CHROME;
}

setPackageFolder(folder);
error = addFile(author, version, 'chrome/' + jarName, folder, null);
if (error == SUCCESS)
{
    var iconfolder = getFolder(getFolder("chrome", "icons"), "default");
    //addFile(name, "imagezoomer.ico", iconfolder, ""); // TODO: make ico file for imagezoomer
    //addFile(name, "imagezoomer.xpm", iconfolder, ""); // TODO: make xpm file for imagezoomer
}
// If adding the JAR file succeeded
if (error == SUCCESS)
{
    folder = getFolder(folder, jarName);
    registerChrome(contentFlag, folder, "content/");
    //registerChrome(localeFlag, folder, "locale/en-US/imagezoomer/"); // cycle through array instead
    for (var i = 0; i < APP_LOCALE_FOLDERS.length; i++)
    {
        registerChrome(localeFlag, folder, APP_LOCALE_FOLDERS[i] + name + "/");
    }
    //registerChrome(skinFlag, folder, "skin/classic/"); // currently not necessary for imagezoomer

    error = performInstall();

    // If the install failed
    if( error == SUCCESS || error == 999)
    {
        alert(displayName + " " + version + SUCCESS_MESSAGE_START + displayName + SUCCESS_MESSAGE);
    }
    else
    {
        alert(INSTALL_FAILURE + error);
        cancelInstall(error);
    }
}
else
{
    alert(JAR_FAILURE_START + error + JAR_FAILURE_MIDDLE + jarName + JAR_FAILURE_END);
    cancelInstall(error);
}
